]> git.lizzy.rs Git - rust.git/blobdiff - ci.sh
expand comment
[rust.git] / ci.sh
diff --git a/ci.sh b/ci.sh
index 922469aeca5425eaa0d9e82cc3cfea746d94e7de..a86c5ca490a40fa06cad32df515f257a132ffdd9 100755 (executable)
--- a/ci.sh
+++ b/ci.sh
@@ -2,9 +2,7 @@
 set -euo pipefail
 
 # Determine configuration
-export RUST_TEST_NOCAPTURE=1
-export RUST_BACKTRACE=1
-export RUSTC_EXTRA_FLAGS="-D warnings"
+export RUSTFLAGS="-D warnings"
 export CARGO_INCREMENTAL=0
 export CARGO_EXTRA_FLAGS="--all-features"
 
@@ -23,29 +21,44 @@ function run_tests {
   fi
 
   ./miri test --locked
-  if ! [ -n "${MIRI_TEST_TARGET+exists}" ]; then
-    # Only for host architecture: tests with MIR optimizations
-    MIRI_TEST_FLAGS="-Z mir-opt-level=3" ./miri test --locked
+  if [ -z "${MIRI_TEST_TARGET+exists}" ]; then
+    # Only for host architecture: tests with optimizations (`-O` is what cargo passes, but crank MIR
+    # optimizations up all the way).
+    MIRIFLAGS="-O -Zmir-opt-level=4" ./miri test --locked
   fi
+
+  # On Windows, there is always "python", not "python3" or "python2".
+  if command -v python3 > /dev/null; then
+    PYTHON=python3
+  else
+    PYTHON=python
+  fi
+
   # "miri test" has built the sysroot for us, now this should pass without
   # any interactive questions.
-  ${PYTHON:-python3} test-cargo-miri/run-test.py
-
+  ${PYTHON} test-cargo-miri/run-test.py
   echo
 }
 
 # host
 run_tests
 
-if [ "${TRAVIS_OS_NAME:-}" == linux ]; then
-  MIRI_TEST_TARGET=i686-unknown-linux-gnu run_tests
-  MIRI_TEST_TARGET=x86_64-apple-darwin run_tests
-  MIRI_TEST_TARGET=i686-pc-windows-msvc run_tests
-elif [ "${TRAVIS_OS_NAME:-}" == osx ]; then
-  MIRI_TEST_TARGET=i686-unknown-linux-gnu run_tests
-  MIRI_TEST_TARGET=x86_64-pc-windows-msvc run_tests
-  MIRI_TEST_TARGET=i686-pc-windows-gnu run_tests
-elif [ "${CI_WINDOWS:-}" == True ]; then
-  MIRI_TEST_TARGET=x86_64-unknown-linux-gnu run_tests
-  MIRI_TEST_TARGET=x86_64-apple-darwin run_tests
-fi
+case $HOST_TARGET in
+  x86_64-unknown-linux-gnu)
+    MIRI_TEST_TARGET=i686-unknown-linux-gnu run_tests
+    MIRI_TEST_TARGET=aarch64-apple-darwin run_tests
+    MIRI_TEST_TARGET=i686-pc-windows-msvc run_tests
+    ;;
+  x86_64-apple-darwin)
+    MIRI_TEST_TARGET=mips64-unknown-linux-gnuabi64 run_tests # big-endian architecture
+    MIRI_TEST_TARGET=x86_64-pc-windows-msvc run_tests
+    ;;
+  i686-pc-windows-msvc)
+    MIRI_TEST_TARGET=x86_64-unknown-linux-gnu run_tests
+    MIRI_TEST_TARGET=x86_64-apple-darwin run_tests
+    ;;
+  *)
+    echo "FATAL: unknown OS"
+    exit 1
+    ;;
+esac